<?php

namespace gp\controleurs;

use gp\modeles\Comment;
use gp\vues\VueComment;
use Slim\Slim;

class ControleurComment
{
    public function getComment($id){
        $comment = Comment::where('id', '=', $id)->first();
        $v = new VueComment(json_encode($comment));
        $v->render();
    }
    public function getComments() {
        $results = null;
        if(isset($_GET['page'])) {
            $page = filter_var($_GET['page'], FILTER_SANITIZE_NUMBER_INT);
            ini_set('memory_limit', '512M');
            $response = Comment::paginate(50, ['*'], 'page', $page);
            $json = (json_decode(json_encode($response), true));
            $route = explode('bdappli_laurent_vonderscher_sassu_percin/GamePedia', Slim::getInstance()->urlFor('getComments'));
            foreach ($json['data'] as $comment) {
                $url = $route[1] . "{$comment['id']}";
                $results['comments'][] = ["comment" => $comment, "links" => ["self" => ["href" => $url]]];
            }
            $prev = $json['prev_page_url'];
            $next = $json['next_page_url'];
            if ($next == '') $next = $json['first_page_url'];
            if ($prev == '') $prev = $json['last_page_url'];
            $links = ["prev" => ["href" => "/api/comments{$prev}"], "next" => ["href" => "/api/comments{$next}"]];
            $results['links'] = $links;
        }
        $v = new VueComment(json_encode($results));
        $v->render();
    }
    public function postComment($id){
        // Takes raw data from the request
        $json = file_get_contents('php://input');
        $data = json_decode($json, true);
        if (isset($data) && $data != null && isset($data['email']) && isset($data['title']) && isset($data['content'])) {
                //sans filter var pour les test
                $results = Comment::create($id, $data['email'], $data['title'], $data['content'], date("Y-m-d H:i:s"));
                $route = explode('bdappli_laurent_vonderscher_sassu_percin/GamePedia', Slim::getInstance()->urlFor('getComments'));
                Slim::getInstance()->response->redirect($route[1].$results->id, 201);
        } else Slim::getInstance()->response->setStatus(500);
    }
}