<?php

namespace gp\controleurs;

use gp\modeles\Comment;
use gp\vues\VuePlatform;
use Slim\Slim;

class ControleurPlatform
{
    public function getPlatform($id){
        $platform = Platform::where('id', '=', $id)->first();
        $v = new VuePlatform(json_encode($platform));
        $v->render();
    }
    public function getPlatforms() {
        $results = null;
        if(isset($_GET['page'])) {
            $page = filter_var($_GET['page'], FILTER_SANITIZE_NUMBER_INT);
            ini_set('memory_limit', '512M');
            $response = Platform::paginate(20, ['*'], 'page', $page);
            $json = (json_decode(json_encode($response), true));
            $route = explode('bdappli_laurent_vonderscher_sassu_percin/GamePedia', Slim::getInstance()->urlFor('getPlatforms'));
            foreach ($json['data'] as $platform) {
                $url = $route[1] . "{$platform['id']}";
                $results['platforms'][] = ["platform" => $platform, "links" => ["self" => ["href" => $url]]];
            }
            $prev = $json['prev_page_url'];
            $next = $json['next_page_url'];
            if ($next == '') $next = $json['first_page_url'];
            if ($prev == '') $prev = $json['last_page_url'];
            $links = ["prev" => ["href" => "/api/platforms{$prev}"], "next" => ["href" => "/api/platforms{$next}"]];
            $results['links'] = $links;
        }
        $v = new VuePlatform(json_encode($results));
        $v->render();
    }
}